<?php

include_once(dirname(__FILE__).'/Base.php');

class TypeOneToMany extends TypeBase
{
  function OnView($Item)
  {
    $Type = $this->System->Type->TypeDefinitionList[$Item['Type']];
    if($Item['Value'] != '')
    {
      if(array_key_exists('View', $Type['Parameters'])) $Table = $Type['Parameters']['View'];
        else $Table = $Type['Parameters']['Table'];
      $DbResult = $this->System->Database->query('SELECT '.$Type['Parameters']['Name'].
        ' AS `Name` FROM '.$Table.' WHERE `'.
        $Type['Parameters']['Id'].'`='.$Item['Value']);
      $DbRow = $DbResult->fetch_assoc();
      $Output = '<a href="?t='.$Type['Parameters']['Table'].'&amp;a='.
        'view'.'&amp;id='.$Item['Value'].'">'.$DbRow['Name'].'</a>';
    } else $Output = '';
    return($Output);
  }

  function OnEdit($Item)
  {
    $Output = '<select name="'.$Item['Name'].'">';
    $Type = $this->System->Type->TypeDefinitionList[$Item['Type']];
    if(array_key_exists('Condition', $Type['Parameters'])) $Where = ' WHERE '.$Type['Parameters']['Condition'];
      else $Where = '';
    if(array_key_exists('Null', $Item) and $Item['Null']) 
    {
      if($Item['Value'] == NULL) $Selected = ' selected="1"'; else $Selected = '';
      $Output .= '<option value=""'.$Selected.'></option>';
    }
    if(array_key_exists('View', $Type['Parameters'])) $Table = $Type['Parameters']['View'];
      else $Table = $Type['Parameters']['Table'];
    $DbResult = $this->System->Database->query('SELECT '.$Type['Parameters']['Name'].' AS `Name`,'.$Type['Parameters']['Id'].' AS `Id` FROM '.$Table.''.$Where.' ORDER BY `Name`');
    while($DbRow = $DbResult->fetch_assoc())
    {
      if($Item['Value'] == $DbRow['Id']) $Selected = ' selected="1"'; else $Selected = '';
      $Output .= '<option value="'.$DbRow['Id'].'"'.$Selected.'>'.$DbRow['Id'].': '.$DbRow['Name'].'</option>';
    }
    $Output .= '</select>';
    return($Output);
  }

  function OnLoad($Item)
  {
    if($_POST[$Item['Name']] == '') return(NULL);
      else return($_POST[$Item['Name']]);
  }

  function OnLoadDb($Item)
  {
    if($Item['Value'] == '') return(NULL);
      else return($Item['Value']);
  }
}

?>
